hdu 5355 Cake dfs暴搜 构造

来源:互联网 发布:js跳转页面弹出新页面 编辑:程序博客网 时间:2024/06/05 20:12

链接:http://acm.hdu.edu.cn/showproblem.php?pid=5355

Cake

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 1438    Accepted Submission(s): 221
Special Judge


Problem Description
There are m soda and today is their birthday. The 1-st soda has prepared n cakes with size 1,2,,n. Now 1-st soda wants to divide the cakes into m parts so that the total size of each part is equal. 

Note that you cannot divide a whole cake into small pieces that is each cake must be complete in the m parts. Each cake must belong to exact one of m parts.
 

Input
There are multiple test cases. The first line of input contains an integer T, indicating the number of test cases. For each test case:

The first contains two integers n and m (1n105,2m10), the number of cakes and the number of soda.
It is guaranteed that the total number of soda in the input doesn’t exceed 1000000. The number of test cases in the input doesn’t exceed 1000.
 

Output
For each test case, output "YES" (without the quotes) if it is possible, otherwise output "NO" in the first line.

If it is possible, then output m lines denoting the m parts. The first number si of i-th line is the number of cakes in i-th part. Then si numbers follow denoting the size of cakes in i-th part. If there are multiple solutions, print any of them.
 

Sample Input
41 25 35 29 3
 

Sample Output
NOYES1 52 1 42 2 3NOYES3 1 5 93 2 6 73 3 4 8
 


题意:把有n块蛋糕, 大小分别是1-n。  分给m个人, 个数随便,大小和要全相等。

做法:

官方题解:





其实那两个不合法的情况,做比赛时队友已经发现了。后来按照 最大的 和某一个小的数 凑对,贪心来做。 比赛时Ac了。赛后数据加强 ,这种方法在数据23 6时会有bug。

然后根据题解,在数字大于m*4 的时候  从大到小,  蛇形分配。 

就像这样。
50 5
YES
10 50 41 40 31 30 21 20 11 10 1
10 49 42 39 32 29 22 19 12 9 2
10 48 43 38 33 28 23 18 13 8 3
10 47 44 37 34 27 24 17 14 7 4
10 46 45 36 35 26 25 16 15 6 5 


55 5
YES
10 55 46 45 36 35 26 25 16 15 9
10 54 47 44 37 34 27 24 17 14 10
10 53 48 43 38 33 28 23 18 13 11
11 52 49 42 39 32 29 22 19 12 8 4
14 51 50 41 40 31 30 21 20 7 6 5 3 2 1


然后剩下的 爆搜就行了。

#include<stdio.h>#include<string.h>#include<stdlib.h>#include<queue>#include<math.h>#include<vector>#include<map>#include<set>#include<cmath>#include<string>#include<algorithm>#include<iostream>#define exp 1e-10#define ll __int64using namespace std;vector<int> men[11];int nw[11];int ping;int m; int flag;void dfs(int num)//还剩下num个 {if(num==0){flag=1;return ;}if(flag)return ;for(int i=1;i<=m;i++){if(nw[i]+num<=ping){nw[i]+=num;men[i].push_back(num);dfs(num-1);if(flag)return ;men[i].pop_back();nw[i]-=num; }}}int main(){int t,n;scanf("%d",&t);while(t--){scanf("%d%d",&n,&m);ll sum=(ll)(1+n)*n/2;ll ave=sum/m;if(sum%m||ave<n){puts("NO");continue;}for(int i=1;i<=m;i++)men[i].clear();int num=n;for(int i=n;i>=4*m;)// 1 - i 可以用{for(int j=1;j<=m;j++){men[j].push_back(i);i--;}for(int j=m;j>=1;j--){men[j].push_back(i);i--;}num=i;}//还剩下 1 -  num  爆搜memset(nw,0,sizeof nw);ping=(1+num)*num/2/m;flag=0;dfs(num);puts("YES");for(int i=1;i<=m;i++){printf("%d",men[i].size());for(int j=0;j<men[i].size();j++){printf(" %d",men[i][j]);}puts("");}}return 0;}













0 0
原创粉丝点击